authwrap/urls.py
from django.conf.urls import patterns, url
from django.contrib import admin

from . import views

admin.autodiscover()

urlpatterns = patterns(
    '',
    url(r'^$', views.profile, name='profile'),
    url(r'^login/$', views.login, name='login'),
    url(r'^logout/$', views.logout, name='logout'),
    url(r'^register/$', views.register, name='register'),
    url(r'^deactivate/$', views.deactivate, name='deactivate'),
    url(r'^send-activation/$', views.send_activation, name='send-activation'),
    url(r'^forgot-password/$', views.forgot_password, name='forgot-password'),
    url(r'^change-password/$', views.change_password, name='change-password'),
    url(r'^change-email/$', views.change_email, name='change-email'),

    url(r'^reset-password/(?P<token>[\w\d]+)/$', views.reset_password, name='reset-password'),
    url(r'^activate/(?P<token>[\w\d]+)/$', views.activate, name='activate'),
    url(r'^activate-email/(?P<token>[\w\d]+)/$', views.activate_email, name='activate-email'),

    url(r'^view-email/(?P<access>[\w\d]+)/$', views.view_email, name='view-email'),
)

urls.py
from django.conf.urls import patterns, include, url
from django.views.generic import TemplateView
import example.views

urlpatterns = patterns(
    "",
    url(r"^$", example.views.home, name='home'),
    url(r"^account/", include('authwrap.urls', namespace='authwrap')),
)

authwrap/forms.py
from django import forms
from django.contrib.auth.hashers import check_password
from django.contrib.auth import get_user_model
# from authwrap.models import Account


class LoginForm(forms.Form):

    email = forms.EmailField(widget=forms.widgets.TextInput)
    password = forms.CharField(widget=forms.widgets.PasswordInput)
    account = get_user_model()

    def is_valid(self):

        valid = super(LoginForm, self).is_valid()
        if not valid:
            return valid

        password = self.cleaned_data['password']
        email = self.cleaned_data['email']

        try:
            acct = self.account.objects.get(email=email)

            if check_password(password, acct.password) is False:
                self._errors['password'] = \
                    ['That email password combination could not be found']
                return False

            if acct.is_active is False:
                self._errors['email'] = ['That account is not active.']
                return False

        except self.account.DoesNotExist:
            self._errors['email'] = ['That email does not exist']
            return False

        return True

    class Meta:
        fields = ['email', 'password']


class RegistrationForm(forms.ModelForm):

    email = forms.EmailField(required=True)
    password1 = forms.CharField(
        label="Password",
        widget=forms.PasswordInput(attrs={
            'autocomplete': 'off'
        }),
    )
    password2 = forms.CharField(
        label="Confirm your password",
        widget=forms.PasswordInput(attrs={
            'autocomplete': 'off'
        }),
    )
    account = get_user_model()

    def is_valid(self):

        valid = super(RegistrationForm, self).is_valid()
        if not valid:
            return valid

        email = self.cleaned_data['email']

        if self.account.objects.filter(email=email).exists():
            self._errors['email'] = ['That email already exists']
            return False

        p1 = self.cleaned_data['password1']
        p2 = self.cleaned_data['password2']

        p1_p2_match = self.account.check_passwords_match(p1, p2)
        if p1_p2_match:
            self._errors = p1_p2_match
            return False

        return True

    class Meta:
        model = get_user_model()
        exclude = ('last_login', 'password', 'is_admin', 'is_active')


class ChangeEmailForm(forms.Form):

    email = forms.EmailField(label="New Email Address",
                             required=True)
    account = get_user_model()

    def is_valid(self):
        valid = super(ChangeEmailForm, self).is_valid()
        if not valid:
            return valid

        try:
            self.account.objects.get(email=self.cleaned_data['email'])
            self._errors['email'] = ['That email already exists']
            return False
        except self.account.DoesNotExist:
            return True

    class Meta:
        fields = ('email',)


class ChangePasswordForm(forms.Form):

    password1 = forms.CharField(
        label="Enter new password",
        widget=forms.PasswordInput(attrs={
            'autocomplete': 'off'
        }),
        required=True,
    )
    password2 = forms.CharField(
        label="Confirm new password",
        widget=forms.PasswordInput(attrs={
            'autocomplete': 'off'
        }),
        required=True,
    )
    account = get_user_model()

    def is_valid(self):
        valid = super(ChangePasswordForm, self).is_valid()
        if not valid:
            return valid

        p1 = self.cleaned_data['password1']
        p2 = self.cleaned_data['password2']

        p1_p2_match = self.account.check_passwords_match(p1, p2)
        if p1_p2_match:
            self._errors = p1_p2_match
            return False

        return True

    class Meta:
        fields = ('password1', 'password2')


class ActivationForm(forms.Form):

    email = forms.EmailField(required=True)
    account = get_user_model()

    class Meta:
        model = get_user_model()
        fields = ('email',)

    def is_valid(self):

        valid = super(ActivationForm, self).is_valid()
        if not valid:
            return valid

        try:
            acct = self.account.objects.get(email=self.cleaned_data['email'])
        except self.account.DoesNotExist:
            self._errors['email'] = ['That email does not exist']
            return False

        if acct.is_active is True:
            self._errors['email'] = ['That account is already active']
            return False

        return True


class ForgotPasswordForm(forms.Form):

    email = forms.EmailField(required=True)
    account = get_user_model()

    class Meta:
        fields = ('email',)

    def is_valid(self):

        valid = super(ForgotPasswordForm, self).is_valid()
        if not valid:
            return valid

        try:
            acct = self.account.objects.get(email=self.cleaned_data['email'])
        except self.account.DoesNotExist:
            self._errors['email'] = ['That email does not exist']
            return False

        return True

authwrap/views.py
from django.shortcuts import render, get_object_or_404
from django.http import HttpResponseRedirect, HttpResponse
from django.core.urlresolvers import reverse
from django.contrib import auth
from django.contrib.auth.decorators import login_required
from django.contrib.auth import get_user_model

from .ajax_responses import win, fail
from .decorators import anonymous_required
from .models import Token, Mail
from .forms import (RegistrationForm,
                    ActivationForm,
                    ForgotPasswordForm,
                    ChangeEmailForm,
                    ChangePasswordForm,
                    LoginForm)


@anonymous_required
def login(request):

    needs_activation = False
    if 'next' in request.GET:
        goto_next = request.GET['next']
    elif 'next' in request.POST:
        goto_next = request.POST['next']
    else:
        goto_next = ''

    if not request.POST:
        return render(request,
                      'authwrap/login.html',
                      {'login_form': LoginForm(),
                       'next': goto_next})

    form = LoginForm(request.POST)
    if form.is_valid():
        user = auth.authenticate(
            email=form.cleaned_data['email'],
            password=form.cleaned_data['password'])
        auth.login(request, user)
        if request.is_ajax():
            return win({'needs_activation': False,
                        'next': goto_next})
        else:
            if goto_next != '':
                return HttpResponseRedirect(goto_next)
            else:
                return HttpResponseRedirect(reverse('home'))

    if 'email' in form.errors \
            and 'not active' in form.errors['email'][0]:
        needs_activation = True

    if request.is_ajax():
        return fail('form_errors',
                    form.errors,
                    {'needs_activation': needs_activation,
                     'next': goto_next})
    else:
        return render(request,
                      'authwrap/login.html',
                      {'login_form': form,
                       'needs_activation': needs_activation,
                       'next': goto_next})


@anonymous_required
def register(request):

    registered = False
    if not request.POST:
        return render(request,
                      'authwrap/register.html',
                      {'registration_form': RegistrationForm(),
                       'registered': registered})

    form = RegistrationForm(request.POST)
    if form.is_valid():
        form.instance.is_active = False
        form.instance.is_admin = False
        acct = form.save()
        acct.assign_password(form.cleaned_data['password1'])
        acct.send_email_with_token('ACTIVATION')
        registered = True
        if request.is_ajax():
            return win({'registered': True})

    if request.is_ajax():
        return fail('form_errors',
                    form.errors,
                    {'registered': registered})
    else:
        return render(request,
                      'authwrap/register.html',
                      {'registration_form': form,
                       'registered': registered})


@anonymous_required
def send_activation(request):

    activation_sent = False
    if not request.POST:
        return render(request,
                      'authwrap/send_activation.html',
                      {'form': ActivationForm()})

    form = ActivationForm(request.POST)
    if form.is_valid():
        account = get_user_model()
        acct = account.objects.get(email=form.cleaned_data['email'])
        acct.send_email_with_token('ACTIVATION')
        activation_sent = True
        if request.is_ajax():
            return win({'activation_sent': True})

    if request.is_ajax():
        return fail('form_errors', form.errors)
    else:
        return render(request,
                      'authwrap/send_activation.html',
                      {'form': form,
                       'reset_sent': activation_sent})


@anonymous_required
def forgot_password(request):

    reset_sent = False
    if not request.POST:
        return render(request,
                      'authwrap/forgot_password.html',
                      {'form': ForgotPasswordForm()})

    form = ForgotPasswordForm(request.POST)
    if form.is_valid():
        account = get_user_model()
        acct = account.objects.get(email=form.cleaned_data['email'])
        acct.send_email_with_token('FORGOT_PASSWORD')
        reset_sent = True
        if request.is_ajax():
            return win({'reset_sent': reset_sent})

    if request.is_ajax():
        return fail('form_errors', form.errors)
    else:
        return render(request,
                      'authwrap/forgot_password.html',
                      {'form': form,
                       'reset_sent': reset_sent})


@login_required
def profile(request):
    return render(request, 'authwrap/profile.html')


@login_required
def change_password(request):

    password_changed = False
    if not request.POST:
        return render(request,
                      'authwrap/change_password.html',
                      {'form': ChangePasswordForm})

    form = ChangePasswordForm(request.POST)
    if form.is_valid():
        acct = request.user
        acct.assign_password(form.cleaned_data['password1'], True)
        auth.update_session_auth_hash(request, acct)
        password_changed = True
        if request.is_ajax():
            return win({'password_changed': password_changed})

    if request.is_ajax():
        return fail('form_errors', form.errors)
    else:
        return render(request,
                      'authwrap/change_password.html',
                      {'form': form,
                       'password_changed': password_changed})


@login_required
def change_email(request):
    email_changed = False
    if not request.POST:
        return render(request,
                      'authwrap/change_email.html',
                      {'form': ChangeEmailForm})

    form = ChangeEmailForm(request.POST)
    if form.is_valid():
        # temporarily change email to send to new address
        email = form.cleaned_data['email']
        acct = get_user_model().objects.get(pk=request.user.pk)
        acct.email = email
        acct.send_email_with_token('CHANGE_EMAIL', email)
        email_changed = True
        if request.is_ajax():
            return win({'email_changed': email_changed})

    if request.is_ajax():
        return fail('form_errors', form.errors)
    else:
        return render(request,
                      'authwrap/change_email.html',
                      {'form': form,
                       'email_changed': email_changed})


@login_required
def deactivate(request):
    if not request.POST:
        return render(request,
                      'authwrap/deactivation.html')

    acct = request.user
    acct.is_active = False
    acct.save()
    auth.logout(request)
    redirect = "%s?msg=DEACTIVATED" % reverse('home')
    return HttpResponseRedirect(redirect)


# backdoor login
def activate(request, token):
    token = get_object_or_404(Token,
                              token=token,
                              token_type='ACTIVATION')

    if request.user \
            and request.user.is_authenticated() \
            and request.user != token.user:
        auth.logout()

    acct = token.user
    acct.is_active = 1
    acct.save()
    token.delete()
    acct.backend = 'django.contrib.auth.backends.ModelBackend'
    auth.login(request, acct)
    return HttpResponseRedirect(reverse('home'))


# backdoor login
def activate_email(request, token):
    token = get_object_or_404(Token,
                              token=token,
                              token_type='CHANGE_EMAIL')

    if request.user \
            and request.user.is_authenticated() \
            and request.user != token.user:
        auth.logout()

    if not request.user.is_authenticated():
        token.user.backend = 'django.contrib.auth.backends.ModelBackend'
        auth.login(request, token.user)

    acct = token.user
    acct.email = token.data
    acct.save()
    token.delete()
    redirect = "%s?msg=EMAIL_ACTIVATED" % reverse('home')
    return HttpResponseRedirect(redirect)


# backdoor login
def reset_password(request, token):
    token = get_object_or_404(Token,
                              token=token,
                              token_type='FORGOT_PASSWORD')

    if request.user \
            and request.user.is_authenticated() \
            and request.user != token.user:
        auth.logout()

    if token.user.is_active is False:
        token.user.is_active = True
        token.user.save()
        Token.objects\
            .filter(user=token.user,
                    token_type='ACTIVATION')\
            .delete()

    token.delete()
    token.user.backend = 'django.contrib.auth.backends.ModelBackend'
    auth.login(request, token.user)
    return HttpResponseRedirect(reverse('authwrap:change-password'))


def logout(request):
    auth.logout(request)
    return HttpResponseRedirect(reverse('home'))


def view_email(request, access):
    email = get_object_or_404(Mail, access=access)
    return HttpResponse(email.html_message)

authwrap/templates/authwrap/forms/change_email.html
{% load bootstrap %}
<h3>Update your email</h3>
<hr/>
<blockquote>Your current email is: {{ user.email }}</blockquote>

{% if email_changed %}
<p class="bg-success">
    An email has been sent with a link to confirm this email address.
</p>
<p class="well well-sm">
    Note: Your login email is still <strong>{{ user.email }}</strong> until you
    confirm this new address.
</p>
{% endif %}
<form method="POST" action="{% url 'authwrap:change-email' %}">
    {{ form|bootstrap }}
    {% csrf_token %}
    <input class="btn btn-primary" type="submit" value="Update email" />
</form>

authwrap/templates/authwrap/forms/change_password.html
{% load bootstrap %}
<form method="POST" action="{% url 'authwrap:change-password' %}">
    <h3>Update your password</h3>
    <hr/>
    {% if password_changed %}
    <p class="bg-success">
        Your password has been updated! And an email has been sent<br>
        confirming this.
    </p>
    {% endif %}
    {{ form|bootstrap }}
    {% csrf_token %}
    <input class="btn btn-primary" type="submit" value="Update Password" />
</form>

authwrap/templates/authwrap/forms/deactivation.html
{% load bootstrap %}
<form action="{% url 'authwrap:deactivate' %}" method="POST">
    <h3>Are you sure you want to deactivate your account?</h3>
    <hr/>
    {% csrf_token %}
    <input type="submit" class="btn btn-primary" value="Deactivate My Account" />
</form>

authwrap/templates/authwrap/forms/edit_account.html
{% load widget_tweaks %}
<form id="edit-account" class="navbar-form pull-left" method="POST">
    <div class="clearfix form-group">
        {% for field in edit_account_form.visible_fields %}
        <div class="col-sm-4">
            {{ field.label_tag }}
            <div class="text-danger pull-right"
                 data-error="{{ field.name }}"></div>
        </div>
        <div class="col-sm-8">
            {% render_field field class+="form-control" autocomplete="off" %}
        </div>
        {% endfor %}
        <div class="col-sm-12">
            <p class="text-danger" data-error="__all__"></p>
            {% csrf_token %}
            <input class="btn btn-default" type="submit" value="Update Account" />
        </div>
    </div>
</form>

authwrap/templates/authwrap/forms/forgot_password.html
{% load bootstrap %}
<h3><strong>Reset your password</strong></h3>
<hr/>
{% if reset_sent %}
<p class="bg-success">
    An email has been sent with a link to reset your password
</p>
{% endif %}
<p class="lead">
    Forgotten your password? Enter your email address below,<br>
    and we'll send you an email allowing you to reset it.
</p>
<form method="POST" action="{% url 'authwrap:forgot-password' %}">
    {{ form|bootstrap }}
    {% csrf_token %}
    <input class="btn btn-primary" type="submit" value="Reset my password" />
    <a href="{% url 'authwrap:login' %}" class="form-alt-link pull-right">Back to Login</a>
</form>

authwrap/templates/authwrap/forms/login.html
{% load bootstrap %}
<h3>Log in to an existing account</h3>
<hr/>
{% if needs_activation %}
<p class="bg-info">
    Your account is not currently active.<br>
    Click <a href="{% url 'authwrap:send-activation' %}">here</a>
    to send another activation email.
</p>
{% endif %}
<form method="POST" action="{% url 'authwrap:login' %}">
    {{ login_form|bootstrap }}
    {% csrf_token %}
    <input type="hidden" name="next" value="{{ next }}" />
    <input class="btn btn-primary" type="submit" value="Login" />
    <div class="pull-right text-right">
        <a href="{% url 'authwrap:forgot-password' %}">Forgot your password?</a><br>
        <a href="{% url 'authwrap:register' %}">Register</a>
    </div>
</form>

authwrap/templates/authwrap/forms/register.html
{% load bootstrap %}
<h3>Register a new account</h3>
<hr/>
{% if registered %}
<p class="bg-success">
    You have successfully registered!<br>
    An email has been sent for you to confirm your account.
</p>
<p class="well well-sm">Please
    <a href="mailto:{{ SUPPORT_EMAIL }}" target="_blank">get in contact</a>
    or <a href="{% url 'authwrap:send-activation' %}" target="_blank">resend the activation email</a>
    if you have any problems.
</p>
{% endif %}
<form method="POST" action="{% url 'authwrap:register' %}">
    {{ registration_form|bootstrap }}
    {% csrf_token %}
    <input type="hidden" name="next" value="{{ next }}" />
    <input class="btn btn-primary" type="submit" value="Register" />
    <a class="pull-right" href="{% url 'authwrap:login' %}">Already a member? Login here.</a>
</form>

authwrap/templates/authwrap/forms/send_activation.html
{% load bootstrap %}
<h3>Resend Activation</h3>
<hr/>
<p>
    Your account is not currently active. <br>
    Fill out the form to receive a new activation link.
</p>
{% if reset_sent %}
<div class="bg-success">
    <p>
        An email has been sent with a link to <br>
        activate your account
    </p>
</div>
{% endif %}

<form method="POST"
      action="{% url 'authwrap:send-activation' %}">
    {{ form|bootstrap }}
    {% csrf_token %}
    <input class="btn btn-primary" type="submit" value="Send my activation code" />
</form>